"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _less = require("less/lib/less/");

var _less2 = _interopRequireDefault(_less);

var _Variable = require("../tree/Variable");

var _Variable2 = _interopRequireDefault(_Variable);

var _Condition = require("../tree/Condition");

var _Condition2 = _interopRequireDefault(_Condition);

var _Negative = require("../tree/Negative");

var _Negative2 = _interopRequireDefault(_Negative);

var _functions = require("../functions");

var functions = _interopRequireWildcard(_functions);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

exports.default = function (source) {
    var less = new _less2.default();
    less.tree.Variable = _Variable2.default;
    less.tree.Condition = _Condition2.default;
    less.tree.Negative = _Negative2.default;
    less.functions.functionRegistry.addMultiple(functions);
    less.PluginLoader = function PluginLoader() {
        _classCallCheck(this, PluginLoader);
    };

    var root = void 0,
        imports = void 0,
        options = void 0;
    less.parse(source, {}, function (e, _root, _imports, _options) {
        if (e) {
            console.error(e);
        }
        root = _root;
        imports = _imports;
        options = _options;
    });
    if (!root) {
        console.error("Failed to parse", source);
        return source;
    }
    // Disables the validation: Properties must be inside selector blocks. They cannot be in the root
    root.firstRoot = false;

    var parseTree = new less.ParseTree(root, imports);

    var _parseTree$toCSS = parseTree.toCSS(options),
        css = _parseTree$toCSS.css;

    return css;
};